"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const crypto_1 = __importDefault(require("crypto"));
class Rom {
    constructor(filename, parentfolder = "ModLoader", subfolder = "Roms") {
        this.subfolder = subfolder;
        this.parentfolder = parentfolder;
        this.filename = filename;
        this.hash = crypto_1.default
            .createHash('md5')
            .update(fs_1.default.readFileSync(filename))
            .digest('hex');
        this.filename = path_1.default.parse(this.filename).base;
    }
}
exports.Rom = Rom;
class RomManager {
    constructor() {
        this.roms = new Array();
    }
    _recursiveCall(parent, child) {
        let romsDir = path_1.default.resolve(path_1.default.join(parent, child));
        if (fs_1.default.existsSync(romsDir)) {
            fs_1.default.readdirSync(romsDir).forEach((file) => {
                let p = path_1.default.join(romsDir, file);
                if (fs_1.default.lstatSync(p).isDirectory()) {
                    this._recursiveCall(romsDir, file);
                }
                else {
                    let parse = path_1.default.parse(p);
                    if (parse.ext === '.n64' ||
                        parse.ext === '.z64' ||
                        parse.ext === '.v64' ||
                        parse.ext === '.zip') {
                        let rom = new Rom(p, path_1.default.parse(parent).name, child);
                        this.roms.push(rom);
                    }
                }
            });
        }
    }
    getRoms() {
        this._recursiveCall(path_1.default.join(".", "ModLoader"), "roms");
    }
}
exports.RomManager = RomManager;
//# sourceMappingURL=RomManager.js.map