"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const discord_rpc_1 = __importDefault(require("discord-rpc"));
const clientId = '639491567815622657';
class DiscordPresence {
    constructor(state, details, startTimestamp, endTimestamp, largeImageKey, largeImageText, smallImageKey, smallImageText, instance, partySize, partyMax, matchSecret, spectateSecret, joinSecret) {
        this.state = state;
        this.details = details;
        this.startTimestamp = startTimestamp;
        this.endTimestamp = endTimestamp;
        this.largeImageKey = largeImageKey;
        this.largeImageText = largeImageText;
        this.smallImageKey = smallImageKey;
        this.smallImageText = smallImageText;
        this.instance = instance;
        this.partySize = partySize;
        this.partyMax = partyMax;
        this.matchSecret = matchSecret;
        this.spectateSecret = spectateSecret;
        this.joinSecret = joinSecret;
    }
}
exports.DiscordPresence = DiscordPresence;
class DiscordIntegration {
    constructor() {
        this.ready = false;
        // only needed for discord allowing spectate, join, ask to join
        discord_rpc_1.default.register(clientId);
        this.rpc = new discord_rpc_1.default.Client({ transport: 'ipc' });
        this.presence = new DiscordPresence();
        this.presence.details = "On the launcher";
        this.presence.state = "Looking at settings";
        this.presence.startTimestamp = Date.now();
        this.presence.instance = true;
        this.presence.largeImageKey = "ml64";
        this.presence.largeImageText = "ModLoader64";
        this.rpc.on('ready', () => {
            this.rpc.setActivity(this.presence);
            this.ready = true;
            this.rpc.subscribe('GAME_JOIN', (something) => {
                console.log(something);
            });
        });
        this.rpc.login({ clientId }).catch(console.error);
    }
    reset() {
        if (!this.ready) {
            return;
        }
        this.presence = new DiscordPresence();
        this.presence.details = "On the launcher";
        this.presence.state = "Looking at settings";
        this.presence.startTimestamp = Date.now();
        this.presence.instance = false;
        this.presence.largeImageKey = "ml64";
        this.presence.largeImageText = "ModLoader64";
        this.rpc.setActivity(this.presence);
    }
    setActivity(p) {
        if (!this.ready) {
            return;
        }
        this.presence.details = p.details;
        this.presence.state = p.state;
        if (p.hasOwnProperty("smallImageKey")) {
            this.presence.smallImageKey = p.smallImageKey;
        }
        /* 		if (this.config !== undefined){
                    let i: string = "";
                    console.log(this.config);
                    i += zlib.deflateSync(Buffer.from(JSON.stringify(this.config))).toString('base64');
                    this.presence.instance = true;
                    this.presence.partySize = 1;
                    this.presence.partyMax = 10;
                    this.presence.joinSecret = i;
                    (this.presence as any)["partyId"] = this.config["lobby"];
                    this.presence.instance = true;
                    console.log(this.presence);
                } */
        this.rpc.setActivity(this.presence);
    }
}
exports.DiscordIntegration = DiscordIntegration;
//# sourceMappingURL=discord.js.map