const exports = {};
"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const MessageLayer_1 = require("./MessageLayer");
const electron_1 = require("electron");
const GUITunnel_1 = require("./GUITunnel");
const GUIValues_1 = require("./GUIValues");
const electron_unhandled_1 = __importDefault(require("electron-unhandled"));
var deep = require('deep-equal');
electron_unhandled_1.default();
//@ts-ignore
$.extend($.fn.textbox.methods, {
    //@ts-ignore
    show: function (jq) {
        return jq.each(function () {
            //@ts-ignore
            $(this).next().show();
        });
    },
    //@ts-ignore
    hide: function (jq) {
        return jq.each(function () {
            //@ts-ignore
            $(this).next().hide();
        });
    }
});
class GeneralFormHandler {
    get nickname() {
        let _nickname = document.getElementById('nickname');
        return _nickname.value;
    }
    set nickname(nick) {
        let _nickname = document.getElementById('nickname');
        _nickname.value = nick;
        //@ts-ignore
        $('#nickname').textbox('setText', nick);
    }
    get lobby() {
        let _lobby = document.getElementById('lobby');
        return _lobby.value;
    }
    set lobby(lobby) {
        let _lobby = document.getElementById('lobby');
        _lobby.value = lobby;
        //@ts-ignore
        $('#lobby').textbox('setText', lobby);
    }
    get password() {
        let _password = document.getElementById('password');
        return _password.value;
    }
    set password(pw) {
        let _password = document.getElementById('password');
        _password.value = pw;
        //@ts-ignore
        $('#password').textbox('setText', pw);
    }
    get selectedRom() {
        return SELECTED_ROM;
    }
    set selectedRom(rom) {
        SELECTED_ROM = rom;
    }
    get isOffline() {
        return $('input:checkbox[name=single_player]').is(':checked');
    }
    set isOffline(b) {
        if (b) {
            //@ts-ignore
            $('#single_player').checkbox('check');
        }
        else {
            //@ts-ignore
            $('#single_player').checkbox('uncheck');
        }
    }
    get serverIP() {
        let _s = document.getElementById('otherServerIP');
        return _s.value;
    }
    set serverIP(s) {
        let _s = document.getElementById('otherServerIP');
        _s.value = s;
        //@ts-ignore
        $('#otherServerIP').textbox('setText', s);
    }
    get serverPort() {
        let _s = document.getElementById('otherServerPort');
        return _s.value;
    }
    set serverPort(s) {
        let _s = document.getElementById('otherServerPort');
        _s.value = s;
        //@ts-ignore
        $('#otherServerPort').textbox('setText', s);
    }
    get selfhost() {
        //@ts-ignore
        return $('#selfHost').prop('checked');
    }
    set selfhost(b) {
        if (b) {
            //@ts-ignore
            $('#selfHost').switchbutton('check');
        }
        else {
            //@ts-ignore
            $('#selfHost').switchbutton('uncheck');
        }
    }
    get alternateConnection() {
        //@ts-ignore
        return $('#otherServer').prop('checked');
    }
    set alternateConnection(b) {
        if (b) {
            //@ts-ignore
            $('#otherServer').switchbutton('check');
        }
        else {
            //@ts-ignore
            $('#otherServer').switchbutton('uncheck');
        }
    }
}
const formHandler = new GeneralFormHandler();
let SELECTED_ROM = '';
class WebSideMessageHandlers {
    constructor(emitter, retriever) {
        this.skipLoadOrder = false;
        this.timeouts = [];
        this.layer = new MessageLayer_1.MessageLayer('internal_event_bus', emitter, retriever);
        this.layer.setupMessageProcessor(this);
    }
    doSetup() {
        this.layer.send('electronSetup', {});
    }
    onStatus(status) { }
    folderGeneration(mods, m) {
        mods.mods.forEach((mod) => {
            let key = mod.parentfolder + "/" + mod.subfolder;
            if (!m.has(key)) {
                let o = {
                    text: mod.subfolder,
                    children: [],
                    state: 'closed',
                    attributes: {
                        subfolder: true
                    }
                };
                let parent;
                m.forEach((value, key) => {
                    if (value.text === mod.parentfolder) {
                        parent = value;
                    }
                });
                if (parent !== undefined) {
                    if (parent.hasOwnProperty("children")) {
                        parent.children.push(o);
                    }
                    m.set(key, o);
                }
            }
        });
    }
    onMods(mods) {
        let _mods = document.getElementById("_mods");
        if (_mods !== null) {
            _mods.innerHTML = "";
        }
        let _data = {
            text: 'mods',
            state: 'open',
            children: [],
            attributes: {
                root: true
            }
        };
        let m = new Map();
        let icons = new Map();
        m.set("mods", _data);
        m.set("ModLoader/mods", _data);
        for (let i = 0; i < mods.mods.length; i++) {
            this.folderGeneration(mods, m);
        }
        mods.mods.forEach((mod) => {
            let key = mod.parentfolder + "/" + mod.subfolder;
            if (m.has(key)) {
                let o = m.get(key);
                let r = {
                    text: mod.meta.name,
                    checked: false,
                    attributes: {
                        hash: mod.hash,
                        parent: mod.parentfolder,
                        mod: true,
                        file: mod.file
                    }
                };
                o.children.push(r);
            }
            if (mod.icon !== undefined) {
                if (mod.type === "gif") {
                    icons.set(mod.meta.name, "data:image/gif;base64," + mod.icon);
                }
                else {
                    icons.set(mod.meta.name, "data:image/png;base64," + mod.icon);
                }
            }
        });
        this.setupModTree(mods.baseguiData, _data, icons, mods.guiData);
    }
    setupModTree(base, _data, icons, update = undefined) {
        //@ts-ignore
        $('#_mods').tree({
            data: [
                _data
            ],
            dnd: true,
            animate: true,
            checkbox: function (node) {
                if (!node.hasOwnProperty("children")) {
                    return true;
                }
            },
            onCheck: (node, checked) => {
                let clone = this.getRootData();
                this.layer.send('onModStatusChanged', clone);
            },
            loadFilter: (data, parent) => {
                function forNodes(data, callback) {
                    var nodes = [];
                    for (var i = 0; i < data.length; i++) {
                        nodes.push(data[i]);
                    }
                    while (nodes.length) {
                        var node = nodes.shift();
                        if (callback(node) == false) {
                            return;
                        }
                        if (node.children) {
                            for (var i = node.children.length - 1; i >= 0; i--) {
                                nodes.unshift(node.children[i]);
                            }
                        }
                    }
                }
                forNodes(data, (node) => {
                    this.timeouts.push(setTimeout(() => {
                        if (icons.has(node.text)) {
                            let e = document.getElementById(node.domId);
                            if (e !== null) {
                                e.children[2].style.background = "url('" + icons.get(node.text) + "')";
                                e.children[2].style.backgroundSize = "32px";
                                e.children[2].style.width = "32px";
                                e.children[2].style.height = "32px";
                                e.style.height = "32px";
                                if (e.children[3].className.indexOf("checkbox") === -1) {
                                    e.children[3].className = "";
                                }
                            }
                        }
                    }, 1000));
                });
                return data;
            },
            onBeforeDrag: (node) => {
                if (node.attributes.hasOwnProperty("root")) {
                    return false;
                }
                return true;
            },
            onDragOver: (target, source) => {
                //@ts-ignore
                let node = $("#_mods").tree('getNode', target);
                if (node.hasOwnProperty("children")) {
                    if (source.hasOwnProperty("children")) {
                        return true;
                    }
                    return false;
                }
                return true;
            },
            onBeforeDrop: (target, source, point) => {
                //@ts-ignore
                let node = $("#_mods").tree('getNode', target);
                if (point === "append") {
                    return false;
                }
                if (node.attributes.hasOwnProperty("parent") && source.attributes.hasOwnProperty("parent")) {
                    if (node.attributes.parent !== source.attributes.parent) {
                        return false;
                    }
                }
                return true;
            },
            onDrop: (target, source, point) => {
                let clone = this.getRootData();
                this.layer.send('onModStatusChanged', clone);
            },
            onLoadSuccess: (node, data) => {
                if (this.skipLoadOrder) {
                    return;
                }
                this.skipLoadOrder = true;
                let clone = this.getRootData();
                this.layer.send("onModListLoaded", clone);
                if (base === undefined) {
                    return;
                }
                this.stripUselessDataforComparison(base);
                this.stripUselessDataforComparison(clone);
                if (update !== undefined) {
                    console.log(base);
                    console.log(clone);
                    if (deep(base, clone)) {
                        console.log("Loading load order data.");
                        while (this.timeouts.length > 0) {
                            let a = this.timeouts.shift();
                            clearTimeout(a);
                        }
                        //@ts-ignore
                        $('#_mods').tree('loadData', [update]);
                    }
                    else {
                        console.log("Mods list changed...");
                    }
                }
            }
        });
    }
    getRootData() {
        //@ts-ignore
        let root = $('#_mods').tree('getRoot');
        //@ts-ignore
        let data = $('#_mods').tree('getData', root.target);
        let clone = jQuery.extend(true, {}, data);
        this.cleanupTreeData(clone);
        return clone;
    }
    cleanupTreeData(root) {
        if (root.hasOwnProperty("children")) {
            let children = root.children;
            for (let i = 0; i < children.length; i++) {
                this.cleanupTreeData(children[i]);
            }
        }
        if (root.hasOwnProperty("domId")) {
            delete root["domId"];
        }
        if (root.hasOwnProperty("target")) {
            delete root["target"];
        }
        if (root.hasOwnProperty("id")) {
            delete root["id"];
        }
    }
    stripUselessDataforComparison(root) {
        if (root.hasOwnProperty("children")) {
            let children = root.children;
            for (let i = 0; i < children.length; i++) {
                this.cleanupTreeData(children[i]);
            }
        }
        if (root.hasOwnProperty("state")) {
            delete root["state"];
        }
        if (root.hasOwnProperty("checkState")) {
            delete root["checkState"];
        }
        if (root.hasOwnProperty("_checked")) {
            delete root["_checked"];
        }
    }
    onRoms(roms) {
        let _roms = document.getElementById("_roms");
        if (_roms !== null) {
            _roms.innerHTML = "";
        }
        let _data = {
            text: 'roms',
            state: 'open',
            children: []
        };
        let m = new Map();
        m.set("roms", _data);
        m.set("ModLoader/roms", _data);
        let actualRomObjects = new Map();
        roms.roms.forEach((rom) => {
            let key = rom.parentfolder + "/" + rom.subfolder;
            if (!m.has(key)) {
                let o = {
                    text: rom.subfolder,
                    children: [],
                    state: 'closed',
                    animate: true,
                    attributes: {
                        subfolder: true
                    }
                };
                let parent;
                m.forEach((value, key) => {
                    if (value.text === rom.parentfolder) {
                        parent = value;
                    }
                });
                if (parent !== undefined) {
                    if (parent.hasOwnProperty("children")) {
                        parent.children.push(o);
                    }
                }
                m.set(key, o);
            }
            if (m.has(key)) {
                let o = m.get(key);
                let r = {
                    text: rom.filename,
                    "checked": false,
                    "attributes": {
                        hash: rom.hash
                    }
                };
                o.children.push(r);
                actualRomObjects.set(rom.filename, r);
            }
        });
        //@ts-ignore
        $('#_roms').tree({
            data: [
                _data
            ],
            animate: true,
            checkbox: function (node) {
                if (!node.hasOwnProperty("children")) {
                    return true;
                }
            },
            onCheck: (node, checked) => {
                actualRomObjects.forEach((value, key) => {
                    //@ts-ignore
                    let n = $('#_roms').tree('find', { text: value.text });
                    //@ts-ignore
                    $('#_roms').tree('update', {
                        target: n.target,
                        checked: false
                    });
                });
                //@ts-ignore
                let n = $('#_roms').tree('find', { text: node.text });
                //@ts-ignore
                $('#_roms').tree('update', {
                    target: n.target,
                    checked: true
                });
                SELECTED_ROM = node.text;
            }
        });
        actualRomObjects.forEach((value, key) => {
            //@ts-ignore
            let n = $('#_roms').tree('find', { text: value.text });
            //@ts-ignore
            $('#_roms').tree('update', {
                target: n.target,
                checked: false
            });
        });
        setTimeout(() => {
            //@ts-ignore
            let n = $('#_roms').tree('find', { text: formHandler.selectedRom });
            if (n === null) {
                return;
            }
            //@ts-ignore
            $('#_roms').tree('update', {
                target: n.target,
                checked: true
            });
        }, 1000);
    }
    onConfigLoaded(config) {
        formHandler.nickname = config['NetworkEngine.Client'].nickname;
        formHandler.lobby = config['NetworkEngine.Client'].lobby;
        formHandler.password = config['NetworkEngine.Client'].password;
        formHandler.selectedRom = config['ModLoader64'].rom;
        formHandler.isOffline = config['NetworkEngine.Client'].isSinglePlayer;
        formHandler.alternateConnection = config['NetworkEngine.Client'].forceServerOverride;
        formHandler.selfhost = config['NetworkEngine.Client'].isSinglePlayer;
        formHandler.serverIP = config['NetworkEngine.Client'].ip;
        formHandler.serverPort = config['NetworkEngine.Client'].port;
    }
    onLog(msg) {
        console.log(msg);
    }
    onGUIConfig(gui) {
        setTimeout(() => {
            if (!gui.showAdvancedTab) {
                //@ts-ignore
                var p = $('#tabs').tabs('getTab', 4);
                p.panel('options').tab.hide();
                p.panel('close');
            }
            else {
            }
        }, 1000);
    }
}
__decorate([
    GUITunnel_1.TunnelMessageHandler('onStatus')
], WebSideMessageHandlers.prototype, "onStatus", null);
__decorate([
    GUITunnel_1.TunnelMessageHandler('readMods')
], WebSideMessageHandlers.prototype, "onMods", null);
__decorate([
    GUITunnel_1.TunnelMessageHandler('readRoms')
], WebSideMessageHandlers.prototype, "onRoms", null);
__decorate([
    GUITunnel_1.TunnelMessageHandler('onConfigLoaded')
], WebSideMessageHandlers.prototype, "onConfigLoaded", null);
__decorate([
    GUITunnel_1.TunnelMessageHandler('onLog')
], WebSideMessageHandlers.prototype, "onLog", null);
__decorate([
    GUITunnel_1.TunnelMessageHandler('readGUIConfig')
], WebSideMessageHandlers.prototype, "onGUIConfig", null);
const handlers = new WebSideMessageHandlers(electron_1.ipcRenderer, electron_1.ipcRenderer);
document.addEventListener('DOMContentLoaded', () => {
    setTimeout(() => {
        handlers.doSetup();
    }, 100);
});
let startButton = document.getElementById('start');
if (startButton !== null) {
    startButton.addEventListener('click', () => {
        let clone = handlers.getRootData();
        handlers.layer.send('onModStatusChanged', clone);
        let sp = false;
        handlers.layer.send('onStartButtonPressed', new GUIValues_1.GUIValues(formHandler.nickname, formHandler.lobby, formHandler.password, formHandler.selectedRom, formHandler.isOffline, formHandler.serverIP, formHandler.serverPort, formHandler.selfhost, formHandler.alternateConnection, clone));
    });
}
let inputConfig = document.getElementById('input-config');
if (inputConfig !== null) {
    inputConfig.addEventListener('click', () => {
        handlers.layer.send('onInputConfig', {});
    });
}
let flips = document.getElementById('flips');
if (flips !== null) {
    flips.addEventListener('click', () => {
        handlers.layer.send('onFlips', {});
    });
}
let refreshMods = document.getElementById('refreshMods');
if (refreshMods !== null) {
    refreshMods.addEventListener('click', () => {
        handlers.layer.send('refreshMods', {});
    });
}
let refreshRoms = document.getElementById("refreshRoms");
if (refreshRoms !== null) {
    refreshRoms.addEventListener('click', () => {
        handlers.layer.send("refreshRoms", {});
    });
}
let modBrowser = document.getElementById("modBrowser");
if (modBrowser !== null) {
    modBrowser.addEventListener('click', () => {
        handlers.layer.send("modBrowser", {});
    });
}
//@ts-ignore
$('#single_player').checkbox({
    onChange: (checked) => {
        formHandler.selfhost = checked;
    }
});
//@ts-ignore
$('#selfHost').switchbutton({
    onChange: (checked) => {
        console.log(checked);
        formHandler.isOffline = checked;
    }
});
//# sourceMappingURL=index_renderer.js.map