"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const MessageLayer_1 = require("./MessageLayer");
const GUITunnel_1 = require("./GUITunnel");
const electron_1 = require("electron");
const electron_unhandled_1 = __importDefault(require("electron-unhandled"));
electron_unhandled_1.default();
const hooks = { print: (msg) => { } };
class WebSideMessageHandlers {
    constructor(emitter, retriever) {
        this.layer = new MessageLayer_1.MessageLayer('internal_event_bus', emitter, retriever);
        this.layer.setupMessageProcessor(this);
    }
    onLog(evt) {
        hooks.print(evt);
    }
}
__decorate([
    GUITunnel_1.TunnelMessageHandler('onLog')
], WebSideMessageHandlers.prototype, "onLog", null);
const handlers = new WebSideMessageHandlers(electron_1.ipcRenderer, electron_1.ipcRenderer);
let Convert = require('ansi-to-html');
let convert = new Convert({
    newline: true,
});
function print(msg) {
    let log = document.getElementById('log-container');
    log.innerHTML += convert.toHtml(msg);
    log.scrollTop = log.scrollHeight - log.clientHeight;
}
hooks.print = print;
module.exports = hooks;
//# sourceMappingURL=running_renderer.js.map