"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const PakFormat_1 = require("./PakFormat");
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const request_1 = __importDefault(require("request"));
const download = require('download-file');
let download_dir = "./downloads";
let cores_dir = "./ModLoader/cores";
// Check plugins.
let updatedSomething = false;
if (fs_1.default.existsSync('./ModLoader/cores')) {
    fs_1.default.readdirSync('./ModLoader/cores').forEach((file) => {
        let parse = path_1.default.parse(file);
        if (parse.ext === '.pak') {
            console.log('Found .pak file: ' + parse.base + '.');
            let modPak = new PakFormat_1.Pak(path_1.default.join('./ModLoader/cores', parse.base));
            if (modPak.verify()) {
                for (let i = 0; i < modPak.pak.header.files.length; i++) {
                    if (modPak.pak.header.files[i].filename.indexOf('package.json') > -1) {
                        let meta = JSON.parse(modPak.load(i).toString());
                        if (meta.hasOwnProperty('updateUrl')) {
                            request_1.default(meta.updateUrl, (error, response, body) => {
                                if (!error && response.statusCode === 200) {
                                    const resp = JSON.parse(body);
                                    let pversion = meta.version;
                                    if (pversion !== resp.version) {
                                        console.log('Updating ' + meta.name + '...');
                                        console.log(resp);
                                        let options = {
                                            directory: download_dir,
                                            filename: parse.base,
                                        };
                                        download(resp.url, options, function (err) {
                                            if (err)
                                                throw err;
                                            let pak = new PakFormat_1.Pak(path_1.default.join(download_dir, parse.base));
                                            if (pak.verify()) {
                                                console.log("Pak file verified.");
                                                fs_1.default.copyFileSync(path_1.default.join(download_dir, parse.base), path_1.default.join(cores_dir, parse.base));
                                                fs_1.default.unlinkSync(path_1.default.join(download_dir, parse.base));
                                            }
                                            console.log('Finished updating ' + meta.name + '.');
                                            updatedSomething = true;
                                        });
                                    }
                                    else {
                                        console.log('No update needed: ' + meta.name + '.');
                                    }
                                }
                            });
                        }
                        else {
                            console.log('No update entry found.');
                        }
                        break;
                    }
                }
            }
            else {
                fs_1.default.unlinkSync(path_1.default.join('./ModLoader/cores', parse.base));
            }
        }
    });
}
//# sourceMappingURL=updateCores.js.map