"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const PakFormat_1 = require("./PakFormat");
const fs_1 = __importDefault(require("fs"));
const request_1 = __importDefault(require("request"));
const download = require('download-file');
class GUIUpdater {
    doCheck() {
        if (fs_1.default.existsSync('./app.pak')) {
            let pak = new PakFormat_1.Pak('./app.pak');
            if (pak.verify()) {
                pak.extractAll('./resources');
                fs_1.default.unlinkSync('./app.pak');
            }
            process.exit(1852400485);
        }
        if (fs_1.default.existsSync('readme.md')) {
            return;
        }
        let pkg = JSON.parse(fs_1.default.readFileSync(__dirname + '/package.json').toString());
        request_1.default('https://nexus.inpureprojects.info/ModLoader64/launcher/update/update.json', (error, response, body) => {
            if (error) {
                fs_1.default.writeFileSync('./' + 'updateerror.log', error.toString());
            }
            if (response.statusCode) {
                fs_1.default.writeFileSync('./' + 'update_response.log', response.statusCode.toString());
            }
            if (!error && response.statusCode === 200) {
                const fbResponse = JSON.parse(body);
                if (fbResponse.version !== pkg.version) {
                    let options = {
                        directory: './',
                        filename: 'app.pak',
                    };
                    download(fbResponse.url, options, function (err) {
                        if (err)
                            throw err;
                        if (fs_1.default.existsSync('./app.pak')) {
                            let pak = new PakFormat_1.Pak('./app.pak');
                            if (pak.verify()) {
                                pak.extractAll('./resources');
                                fs_1.default.unlinkSync('./app.pak');
                            }
                            process.exit(1852400485);
                        }
                    });
                }
                else {
                    process.exit(0);
                }
            }
        });
    }
}
exports.GUIUpdater = GUIUpdater;
const update = new GUIUpdater();
update.doCheck();
//# sourceMappingURL=updateGUI.js.map