"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const PakFormat_1 = require("./PakFormat");
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const request_1 = __importDefault(require("request"));
const download = require('download-file');
const fs_extra_1 = __importDefault(require("fs-extra"));
let isDev = fs_1.default.existsSync("./DEV_FLAG.json");
let updateURL = "https://nexus.inpureprojects.info/ModLoader64/update/update.json";
if (isDev) {
    updateURL = "https://nexus.inpureprojects.info/ModLoader64/dev/update.json";
}
request_1.default(updateURL, (error, response, body) => {
    if (!error && response.statusCode === 200) {
        if (fs_1.default.existsSync('./ModLoader.pak')) {
            fs_extra_1.default.removeSync('./ModLoader/src');
            let pak = new PakFormat_1.Pak('./ModLoader.pak');
            pak.extractAll('./');
            fs_1.default.unlinkSync('./ModLoader.pak');
            process.exit(1852400485);
        }
        const fbResponse = JSON.parse(body);
        console.log('Got a response: ', fbResponse);
        let version = 'Nothing';
        console.log(path_1.default.resolve('./update.json'));
        let data = {};
        if (fs_1.default.existsSync('./update.json')) {
            data = JSON.parse(fs_1.default.readFileSync('./update.json').toString());
            version = data.version;
        }
        let options = {
            directory: './',
            filename: 'ModLoader.pak',
        };
        let platformkey = '';
        if (process.env.PROCESSOR_ARCHITECTURE === undefined) {
            platformkey = process.platform.trim() + 'x64';
        }
        else {
            platformkey =
                process.platform.trim() + process.env.PROCESSOR_ARCHITECTURE;
        }
        console.log(platformkey);
        if (version !== fbResponse.version) {
            fs_1.default.writeFileSync('./update.json', JSON.stringify(fbResponse));
            data = JSON.parse(fs_1.default.readFileSync('./update.json').toString());
            download(data[platformkey], options, function (err) {
                if (err)
                    throw err;
                if (fs_1.default.existsSync('./ModLoader.pak')) {
                    fs_extra_1.default.removeSync('./ModLoader/src');
                    let pak = new PakFormat_1.Pak('./ModLoader.pak');
                    if (pak.verify()) {
                        //@ts-ignore
                        let cfg = undefined;
                        if (fs_1.default.existsSync("./ModLoader/emulator/mupen64plus.cfg")) {
                            cfg = fs_1.default.readFileSync("./ModLoader/emulator/mupen64plus.cfg");
                        }
                        pak.extractAll('./');
                        fs_1.default.unlinkSync('./ModLoader.pak');
                        if (cfg !== undefined) {
                            fs_1.default.writeFileSync("./ModLoader/emulator/mupen64plus.cfg", cfg);
                        }
                    }
                    else {
                        fs_1.default.unlinkSync("./update.json");
                        fs_1.default.unlinkSync("./ModLoader.pak");
                        process.exit(1);
                    }
                }
            });
        }
    }
    else {
        console.log('Got an error: ', error, ', status code: ', response.statusCode);
    }
});
//# sourceMappingURL=updateModLoader.js.map